% Independence test adopted from Smith and Batchelder (2008)
M=16;
gamepair=30;
sub_num=18;
polytope=LOP_5gambles;
Fit1sd=zeros(sub_num,gamepair)+2;
Fit2sd=zeros(sub_num,gamepair)+2;
Fit05=zeros(sub_num,gamepair)+2;
bio=zeros(sub_num,gamepair)+2;

% dimdata=zeros(18,6);
for tt=1:9
filename1=strcat('ncg_0',num2str(tt),'.txt');
filename2=strcat('reg_0',num2str(tt),'.txt');
filename3=strcat('new_0',num2str(tt),'.txt');
noncash=textread(filename1);
cash1=textread(filename2);
cash2=textread(filename3);
% dimdata(tt,1:2)=size(cash1);
% dimdata(tt,3:4)=size(cash2);
% dimdata(tt,5:6)=size(noncash);
% end
cash1=cash1(5:20,:);
cash2=cash2(5:20,:);
noncash=noncash(5:20,:);

sub=[cash1 cash2 noncash];
A=zeros(M-1,gamepair)+2; %store A
for j=1:gamepair
    for i=1:(M-1)
        if sub(i,j)==sub(i+1,j)
        A(i,j)=0;
    else A(i,j)=1;
        end
    end
end
empiricalA=sum(A,1); %calculated A_i from real data
%cacluate the MLE from Qtest
choice=[sum(cash1)' M-sum(cash1)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;

bio(tt,1:10)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,1:10)=empiricalA(1:10)>=meanA-1*sdA & empiricalA(1:10)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,1:10)=empiricalA(1:10)>=meanA-1.96*sdA & empiricalA(1:10)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,1:10)=empiricalA(1:10)>=meanA-2*sdA & empiricalA(1:10)<=meanA+2*sdA;    %fit of 2 sd


%cacluate the MLE from Qtest
choice=[sum(cash2)' M-sum(cash2)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;
bio(tt,11:20)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,11:20)=empiricalA(11:20)>=meanA-1*sdA & empiricalA(11:20)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,11:20)=empiricalA(11:20)>=meanA-1.96*sdA & empiricalA(11:20)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,11:20)=empiricalA(11:20)>=meanA-2*sdA & empiricalA(11:20)<=meanA+2*sdA;    %fit of 2 sd

%cacluate the MLE from Qtest
choice=[sum(noncash)' M-sum(noncash)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;
bio(tt,21:30)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,21:30)=empiricalA(21:30)>=meanA-1*sdA & empiricalA(21:30)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,21:30)=empiricalA(21:30)>=meanA-1.96*sdA & empiricalA(21:30)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,21:30)=empiricalA(21:30)>=meanA-2*sdA & empiricalA(21:30)<=meanA+2*sdA;    %fit of 2 sd

end

for tt=10:18
filename1=strcat('ncg_',num2str(tt),'.txt');
filename2=strcat('reg_',num2str(tt),'.txt');
filename3=strcat('new_',num2str(tt),'.txt');
noncash=textread(filename1);
cash1=textread(filename2);
cash2=textread(filename3);
cash1=cash1(5:20,:);
cash2=cash2(5:20,:);
noncash=noncash(5:20,:);
sub=[cash1 cash2 noncash];
% dimdata(tt,1:2)=size(cash1);
% dimdata(tt,3:4)=size(cash2);
% dimdata(tt,5:6)=size(noncash);
% end

A=zeros(M-1,gamepair)+2; %store A
for j=1:gamepair
    for i=1:(M-1)
        if sub(i,j)==sub(i+1,j)
        A(i,j)=0;
    else A(i,j)=1;
        end
    end
end
empiricalA=sum(A,1); %calculated A_i from real data
%cacluate the MLE from Qtest
choice=[sum(cash1)' M-sum(cash1)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;
bio(tt,1:10)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,1:10)=empiricalA(1:10)>=meanA-1*sdA & empiricalA(1:10)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,1:10)=empiricalA(1:10)>=meanA-1.96*sdA & empiricalA(1:10)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,1:10)=empiricalA(1:10)>=meanA-2*sdA & empiricalA(1:10)<=meanA+2*sdA;    %fit of 2 sd


%cacluate the MLE from Qtest
choice=[sum(cash2)' M-sum(cash2)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;
bio(tt,11:20)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,11:20)=empiricalA(11:20)>=meanA-1*sdA & empiricalA(11:20)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,11:20)=empiricalA(11:20)>=meanA-1.96*sdA & empiricalA(11:20)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,11:20)=empiricalA(11:20)>=meanA-2*sdA & empiricalA(11:20)<=meanA+2*sdA;    %fit of 2 sd

%cacluate the MLE from Qtest
choice=[sum(noncash)' M-sum(noncash)'];
cellM=mat2cell(choice,[1 1 1 1 1 1 1 1 1 1],2);
LH=polytope(:,1:10);
RH=polytope(:,11);
[X,L,W,P]=mult_con(cellM,LH, RH);
p=X;
bio(tt,21:30)=X;
meanA=2.*(M-1).*p.*(1-p); %mean of A_i
sdA=sqrt(2.*(M-1).*p.*(1-p).*(1-2.*p.*(1-p))); %sd of A_i
Fit1sd(tt,21:30)=empiricalA(21:30)>=meanA-1*sdA & empiricalA(21:30)<=meanA+2*sdA;   %fit of 1 sd
Fit05(tt,21:30)=empiricalA(21:30)>=meanA-1.96*sdA & empiricalA(21:30)<=meanA+2*sdA; % fit at .05
Fit2sd(tt,21:30)=empiricalA(21:30)>=meanA-2*sdA & empiricalA(21:30)<=meanA+2*sdA;    %fit of 2 sd

end

sum(Fit05(1,1:10),1)